module compliantLink2()
{

module 3prism(rad, ht, thk) {
polyhedron (points=[[rad, 0, ht], [rad * cos(120), rad * sin(120), ht], [rad * cos(240), rad * sin(240), ht], [rad, 0, ht + thk], [rad * cos(120), rad * sin(120), ht + thk], [rad * cos(240), rad * sin(240), ht + thk]], triangles = [[0,1,2],[4,3,5],[1,0,3],[3,4,1],[2,1,4],[4,5,2],[0,2,5],[5,3,0]])  ; }

module 3block(rad1, rad2, ht, wdth, thk) {
	union() {
		rotate(60,[0,0,1]) translate([(rad1+rad2)/2,0,ht + thk/2]) cube(size = [rad1-rad2,wdth,thk], center=true);
		rotate(180,[0,0,1]) translate([(rad1+rad2)/2,0,ht+thk/2]) cube(size = [rad1-rad2,wdth,thk], center=true);
		rotate(300,[0,0,1]) translate([(rad1+rad2)/2,0,ht+thk/2]) cube(size = [rad1-rad2,wdth,thk], center=true);
	}
}

module slice1(rad1, rad2, ht, thk) {
	difference(){
		3prism(rad1,ht,thk);
		3prism(rad2,ht - 0.1,thk + 0.2);
	}
}

module slice2(rad1, rad2, ht, thk) {
	difference(){
		slice1(rad1, rad2, ht, thk);
		3block(1.01*rad1/2,0.99* rad2/2, ht-0.1, 2* rad2 * cos(30),thk+0.2);
	}
}

module comseg(rad1, rad2, ht, thk) {
	union() {
		slice1(rad1, rad2, ht, thk);
		slice2(rad1, rad2, ht+thk, 2*thk);
		3block(rad1/2, rad2/2, ht+thk, (rad1-rad2)/2, 2*thk);
		slice1(rad1, rad2, ht + 3*thk, thk);
		slice2(rad1, rad2, ht + 4*thk, thk);
		slice1(rad1, rad2, ht + 5*thk, thk);
		slice2(rad1, rad2, ht + 6*thk, 2*thk);
		3block(rad1/2, rad2/2, ht + 6*thk, (rad1-rad2)/2,2*thk);
		slice1(rad1, rad2, ht + 8*thk, thk);
		3block(rad1/2, rad2/2, ht + 9*thk, (rad1-rad2)/2, thk);
	}
}

module comblock(rad1, rad2, ht, thk, nseg) {
	for (i = [0:(nseg-1)]) {
		comseg(rad1, rad2, ht + i*10*thk, thk);
	}
}

comblock(2,1,0,0.05, 5);

}
compliantLink2();




